'Program		Singularity
'Version		1.00
'Language		FreeBASIC 0.24 for Linux

'Copyright © 2013 David Watson [david@watzon.co.uk]

'Anyone is permitted to copy, modify, distribute and/or sell this program,
'provided that the copyright notice and permission notices appear in all copies.

'Anyone is permitted to use this program, provided that the user accepts that
'the program is provided "as is" and comes without any warranty.

'Anyone is permitted to integrate parts of the source code of this program into
'their own, provided that the author of this program is duly credited.



'######################### set up variables and screen #########################
dim as short	a,s,x,y,stara(4999),starr(4999)
dim as ubyte	lum(40 to 1000)
dim as single	qc(1023),qs(1023)
dim as any ptr	fb

screenres 1024,512,8
windowtitle "Singularity"
fb=screenptr							'base of video buffer

'initialise stars
for s=0 to 4999
	stara(s)=rnd*1023					'random angle (0 to 1023)
	starr(s)=40+s*0.192					'start radius (40 to 1000)
next s

'set palette to grey scale
for a=0 to 63
	palette a,(a shl 16)+(a shl 8)+a
next a

'create quick look-up tables
for a=0 to 1023
	qs(a)=sin(a*6.135923e-3)*0.5				'scale 1000 radius to 500 pixels
	qc(a)=cos(a*6.135923e-3)*0.075				'scale 1000 radius to 75 pixels
next a

'create luminescence look-up table
for a=40 to 1000
	lum(a)=1+62*sin((a-40)*3.2725e-3)			'sine curve dark-light-dark
next a



'################################## main loop ##################################
do
	screenlock
	cls

	for s=0 to 4999
		x=512+qs(stara(s))*starr(s)
		y=256-qc(stara(s))*starr(s)
		poke ubyte,fb+(y shl 10)+x,lum(starr(s))

		stara(s)=(stara(s)+1) and 1023			'rotate star
		starr(s)=starr(s)-1						'fall toward centre
		if starr(s)<40 then starr(s)=1000		'swallowed stars reborn at edge
	next s

	screenunlock
	sleep 15
loop until inkey<>""

